meta:
  id: spino_payload
  endian: le

seq:
#  - id: header 
#    size: 16
  - id : payload
    type: payload
    

types:
  payload:
    seq:
      - id: size
        type: u2
      - id: cmd_id
        type: u2
      - id: response_type
        type: u1
      - id: error_code
        type: u1
      - id: spare
        type: u2
      - id: timestamps
        type: u8
      - id: responsetype
        type: 
          switch-on: response_type 
          cases:
           0x80: response_typea
           0x10: response_beacon_expe
           0x40: response_typea
           0x41: information_message
           32: response_typea
        if: error_code == 0
        
    instances:
     size_raw:        
       value: size
     cmd_id_raw:
       value: cmd_id
     response_type_raw:
       value: response_type
     error_code_raw:
       value: error_code
     timestamps_s:
       value: timestamps
       
  
  response_beacon_expe: 
    seq:
      - id: size
        type: u2
      - id: id 
        type: u4
      - id: expereceived 
        type: u4
      - id: expereceivedfail
        type: u4      
      - id: expe_delay
        type: u2
      - id: idf
        type: u2

    instances:
     size_raw:        
       value: size
     id_raw:
       value: id
     expereceived_raw:
       value: expereceived
     expereceivedfail_raw:
       value: expereceivedfail
     expe_delay_raw:
       value: expe_delay
     idf_raw:
       value: idf       
       
       
       
       
  information_message:
    seq:
      - id: resp_type
        type: u2
      - id: spare 
        type: u2
      - id: index
        type: u1
      - id: used
        type: u1 
      - id:  message
        encoding: ASCII
        type: str
        size-eos: true

    instances:
     resp_type_raw:        
       value: resp_type        
     spare_raw:        
       value: spare         
     index_raw:        
       value: index 
     used_raw:        
       value: used              
     messagea_raw:        
       value: message 
       
       
  response_typea:
    seq: 
      - id: size
        type: u2     
      - id: response_data
        type: 
          switch-on: _parent.cmd_id 
          cases:
           0x00: telemetry
           0x23: list_mail_box
           0x25: mailbox_message
           0x26: mailbox_message
           0x49: tle
           0x67: configuration
           0x65: response_setdatavalue
           0x66: response_getdatavalue
           76: list_mail_box
           0x78: response_last_drop
           0x79: response_all_drop
           122: response_last_drop
           0x82: response_last_log
           0x86: response_last_log
           0x83: response_all_log
           #0x11: s_frame          
    instances:
     size_raw:        
       value: size       # if: payload.error_code == 0     
     response_data_raw:        
       value: response_data          
           
  telemetry:
    seq:
      - id: nb_commande_received
        type: u4
      - id: nb_commande_with_error
        type: u4
      - id: nb_frame_not_processed
        type: u4
      - id: nb_digipeater_messsage_processed
        type: u4
      - id: nb_experiemntal_command
        type: u4
      - id: nb_experiemntal_command_error
        type: u4
      - id: nb_mailbox_commande_received
        type: u4
      - id: nb_mailbox_error_commande_received
        type: u4
      - id: nb_payload_commande_received
        type: u4
      - id: nb_payload_command_with_error
        type: u4
      - id: timestamps
        type: u8
      - id: last_reset_cause
        type: u2
      - id: current_state
        type: u2
      - id: spare
        type: u4
      - id:  crc
        type: u2

    instances:
     nb_commande_received_raw:        
       value: nb_commande_received
     nb_commande_with_error_raw:        
       value: nb_commande_with_error
     nb_frame_not_processed_raw:        
       value: nb_frame_not_processed
     nb_digipeater_messsage_processed_raw:        
       value: nb_digipeater_messsage_processed
     nb_experiemntal_command_raw:        
       value: nb_experiemntal_command
     nb_experiemntal_command_error_raw:        
       value: nb_experiemntal_command_error
     nb_mailbox_commande_received_raw:        
       value: nb_mailbox_commande_received
     nb_mailbox_error_commande_received_raw:        
       value: nb_mailbox_error_commande_received
     nb_payload_commande_received_raw:        
       value: nb_payload_commande_received
     nb_payload_command_with_error_raw:        
       value: nb_payload_command_with_error
     timestamps_raw:        
       value: timestamps       
     last_reset_cause_raw:        
       value: last_reset_cause       
     current_state_raw:        
       value: current_state       
       
       
  mailbox_message:
    seq:

      - id: timetamps
        type: u8
      - id: callsign
        size: 6
      - id: index 
        type: u1
      - id: value
        size-eos: true 
        
    instances:
     timetamps_s:        
       value: timetamps 
     callsign_raw:        
       value: callsign        
     index_raw:        
       value: index        
     value_raw:        
       value: value        
        
  response_last_drop:
    seq:
      - id: timetamps
        type: u8
      - id: size_msg
        type: u2
      - id:  crc
        type: u2
        
    instances:
     timetamps_s:        
       value: timetamps 
     size_msg_raw:        
       value: size_msg       
     crc_raw:        
       value: crc       
       
        
  response_all_drop:
    seq:
      - id:  message
        size-eos: true 
    instances:
     message_raw:        
       value: message 
       
       
       
  list_mail_box:
    seq:
      - id: indi
        size: 6
      - id: nbmsage
        size: 1
      - id: indi2
        size: 6
      - id: nbmsage2
        size: 1
      - id: value
        size-eos: true 
        
        
        
  response_all_log:
    seq:
      - id:  message
        size-eos: true 
    instances:
     message_raw:        
       value: message 
       
       
  tle:
    seq:
      - id:  message
        encoding: ASCII
        type: str
        size-eos: true    
    instances:
      message_raw:
        value: message          
        
        
        
        
  response_last_log:
    seq:

      - id: timetamps
        type: u8
      - id: priority
        type: u1
      - id:  message
        encoding: ASCII
        type: str
        size-eos: true
    instances:
      timetamps_s:
        value: timetamps 
      priority_raw:
        value: priority 
      message_raw:
        value: message 
        
        
        

        
  response_setdatavalue:
    seq:
      - id: field_id
        type: u1
      - id:  crc
        type: u2
    instances:
      field_id_raw:
        value: field_id 
      crc_raw:
        value: crc 
        
        
  response_getdatavalue:
    seq:
      - id: field_id
        type: u1
      - id: field_size
        type: u1
      - id: value_data
        type:
          switch-on: field_id 
          cases:

           0x80: version
           0x01: spino_delay
           0x02: callsign    
           0x03: callsign  
           0x04: callsign
           0x05: time_stamps
           0x06: log_level
           0x07: active_info_message
           0x08: information_message_delay
           0x09: modem_tx_mode
           0x0A: modem_tx_multi_mode
           
      - id: value_data2
        size-eos: true  
    instances:
      field_id_raw:
        value: field_id        
      field_size_raw:
        value: field_size         
      value_data_raw:
        value: value_data         
  
  
  
  modem_tx_multi_mode:
    seq: 
      - id : modem_tx_multi_mode
        type: u4
    instances:
      modem_tx_multi_mode_raw:
        value: modem_tx_multi_mode  
  
  time_stamps:
    seq: 
      - id : time_stamps
        type: u4
    instances:
      time_stamps_s:
        value: time_stamps
        
  modem_tx_mode:
    seq: 
      - id : modem_tx_mode
        type: u1
    instances:
      modem_tx_mode_raw:
        value: modem_tx_mode

  log_level:
    seq: 
      - id : log_level
        type: u1
    instances:
      log_level_raw:
        value: log_level
        

  active_info_message:
    seq: 
      - id : active_info_message
        type: u1
    instances:
      active_info_message_raw:
        value: active_info_message

      
  version:
    seq: 
      - id : version
        type: u2
    instances:
     version_raw:        
       value: version        
        
  spino_delay:
    seq: 
      - id : spino_delay
        type: u1     
      - id:  crc
        type: u2
        
    instances:
     spino_delay_s:        
       value: spino_delay         
     crc_raw:        
       value: crc          

  information_message_delay:
    seq: 
      - id : information_message_delay
        type: u1     
      - id:  crc
        type: u2
        
    instances:
     information_message_delay_s:        
       value: information_message_delay         
     crc_raw:        
       value: crc

  callsign:
    seq: 
      - id : callsign
        type: str
        encoding: ASCII
        size: 6
      - id:  crc
        type: u2
        
    instances:
     callsign_raw:        
       value: callsign         
     crc_raw:        
       value: crc          

  configuration:
    seq:

      - id: spino_tx_frequency
        type: u4
      - id: spino_rx_frequency
        type: u4
      - id: spino_tx_modem_speed
        type: u2
      - id: spino_rx_modem_speed
        type: u2
      - id: spino_rx_modem_mode
        type: u1
      - id: spino_tx_modem_mode
        type: u1      
      - id: telemetry_delay
        type: u1
      - id: multimode
        type: u1
      - id: info_message_actif
        type: u1
      - id: delay_info_message
        type: u1        
      - id: src_callsign
        type: str
        encoding: ASCII
        size: 6
      - id: dest_callsign
        type: str
        encoding: ASCII
        size: 6
      - id:  payload_callsign
        type: str
        encoding: ASCII
        size: 6
      - id:  crc
        type: u2
#      - id: config_data
#        size-eos: true  
    instances:
     spino_tx_frequency_hz:        
       value: spino_tx_frequency         
     spino_rx_frequency_hz:        
       value: spino_rx_frequency 
     spino_tx_modem_speed_raw:        
       value: spino_tx_modem_speed 
     spino_rx_modem_speed_raw:        
       value: spino_rx_modem_speed 
     spino_rx_modem_mode_raw:        
       value: spino_rx_modem_mode 
     spino_tx_modem_mode_raw:        
       value: spino_tx_modem_mode 
     telemetry_delay_s:        
       value: telemetry_delay 
     multimode_raw:        
       value: multimode 
     info_message_actif_raw:        
       value: info_message_actif 
     delay_info_message_s:        
       value: delay_info_message 
     src_callsign_raw:        
       value: src_callsign 
     dest_callsign_raw:        
       value: dest_callsign  
     payload_callsign_raw:        
       value: payload_callsign 
     crc_raw:        
       value: crc    